Xojo.createNamespace("XTension.motion24");
XojoCustom.XTension.motion24.disableReport = function( thisParent){

	if (! thisParent){
		return;
	}
	
	var thisCanvas = thisParent.children[0];
	
	if (! thisCanvas){

		return;
	}
	
	var ctx = thisCanvas.getContext( '2d');
	ctx.globalAlpha = 0.4;
	ctx.fillStyle = "#C8C8C8";
	ctx.fillRect( 0, 0, thisCanvas.width, thisCanvas.height);
	ctx.globalAlpha = 1;

}

XojoCustom.XTension.motion24.drawReport = function( thisParent, motionReportData, date24){
	if (! thisParent){
		return;
	}
	
	var thisCanvas = thisParent.children[0];
	
	if (! thisCanvas){
		return;
	}
	
	var ctx = thisCanvas.getContext( '2d');

	var hourBlockWidth = Math.floor( (thisCanvas.width-4) / 24);
	var fieldWidth = Math.floor(((hourBlockWidth-5 - 6) / 6));
	var elementHeight = thisCanvas.height - 18;
					
	ctx.clearRect( 0, 0, thisCanvas.width, thisCanvas.height);
	ctx.lineWidth = "1";
	ctx.strokeStyle = "black";
	//necessary to actually draw this color in the canvas otherwise
	//the text doesn't render properly. Cannot rely on the CSS for background color
	ctx.fillStyle = "#444444"; //"rgb( 68, 68, 68);";
	ctx.fillRect( 0, 0, thisCanvas.width, thisCanvas.height);
	
	//draw the lines between the hours
	var i=0;
	for (i=1; i<24; i++){
	
		var offset = (hourBlockWidth * i) + 2;
	
		ctx.beginPath();				
		ctx.moveTo( offset, 0);
		ctx.lineTo( offset, thisCanvas.height);
		ctx.closePath()
		ctx.stroke();
	}


	var textBottom = thisCanvas.height-3;
	ctx.fillStyle = "white";
	
	//draw the time text
	for (i=0; i<24; i++){
		var workTextOffset = (hourBlockWidth * i) + 6;
		if (date24){
			ctx.fillText( i + ":00", workTextOffset, textBottom);
		} else {
			if (i==0){
				ctx.fillText( "12 am", workTextOffset, textBottom);
			} else if (i<12){
				ctx.fillText( i + " am", workTextOffset, textBottom);
			} else if ( i==12){
				ctx.fillText( "12 pm", workTextOffset, textBottom);
			} else {
				ctx.fillText( (i-12) + " pm", workTextOffset, textBottom);
			}
		}
	}

	
	var hourCounter = 0;
	var innerCounter = 0;
	var dataOffset = 0;
	
	
	var lastColor = "";
	var redColor = "#FF4444"; //"rgb( 255, 68, 68);";
	var orangeColor = "#FF9944"; //"rgb( 255, 153, 68);";
	var yellowColor = "#FFFF44"; //"rgb( 255, 255, 68);";
	var greenColor = "#44FF44"; //"rgb( 68, 255, 68);";
	var greyColor =  "#777777"; //"rgb( 119, 119, 119);";
	
	for (hourCounter=1; hourCounter < 25; hourCounter++){
		
		var currentHourOffset = (hourBlockWidth * (hourCounter-1));
	
		for (innerCounter=1; innerCounter < 7; innerCounter++){
			var elementOffset = currentHourOffset + 4 + ((fieldWidth) * (innerCounter-1)) + 6;
			var workBit = "5";
			if (dataOffset <= motionReportData.length){
				workBit = motionReportData.charAt( dataOffset);
			}
			
			var newColor = "";
			dataOffset++;
			
			if (workBit == "0"){
					newColor = greenColor;
					//ctx.fillStyle = "#44FF44"; //rgb( 68, 255, 68);";
			} else if (workBit == "1"){
					newColor = yellowColor;
					//ctx.fillStyle =  "#FFFF44"; //"rgb( 255, 255, 68);";
			} else if (workBit == "2"){
					newColor = orangeColor;
					//ctx.fillStyle = "#FF9944"; //rgb( 255, 153, 68);";
			} else if (workBit == "3"){
					newColor = redColor;
					//ctx.fillStyle = "#FF4444"; //rgb( 255, 68, 68);";
			} else {
					newColor = greyColor;
					//ctx.fillStyle = "#777777"; //rgb( 119, 119, 119);";
			}
			
			if (newColor != lastColor){
				ctx.fillStyle = newColor;
				lastColor = newColor;
			}
			
			ctx.fillRect( elementOffset-1, 4, fieldWidth-1, elementHeight);
			
		}
	}
	
}	